/*
 * Copyright (C) 2013 Snowsun <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.states;

import com.jme3.app.state.AbstractAppState;
import com.jme3.app.state.AppStateManager;
import com.sun.jna.Memory;
import java.io.File;
import javax.swing.JFileChooser;
import org.wyrez.shootingstars.game.GameSettings;
import org.wyrez.shootingstars.gui.SelectTrackGUI;
import org.wyrez.shootingstars.gui.listener.SelectFileListener;
import org.wyrez.shootingstars.helper.ScreenHelper;
import tonegod.gui.core.Screen;
import uk.co.caprica.vlcj.player.MediaPlayerFactory;
import uk.co.caprica.vlcj.player.direct.BufferFormat;
import uk.co.caprica.vlcj.player.direct.DirectMediaPlayer;
import uk.co.caprica.vlcj.player.direct.RenderCallback;

/**
 *
 * @author Snowsun
 */
public class SelectTrackState extends AbstractAppState implements SelectFileListener {

    private static final int SLEEP = 1000;
    /**/
    private StateManager stateManager;
    private GameSettings settings;
    private SelectTrackGUI gui;

    public SelectTrackState(Screen screen, StateManager stateManager, GameSettings settings, ScreenHelper screenHelper) {
        this.stateManager = stateManager;
        this.settings = settings;
        this.gui = new SelectTrackGUI(screen, this, screenHelper);
    }

    @Override
    public void stateAttached(AppStateManager stateManager) {
        gui.attach();
    }

    @Override
    public void stateDetached(AppStateManager stateManager) {
        gui.detach();
    }

    public void selectFile() {
        JFileChooser jFileChooser = new JFileChooser();
        int returnVal = jFileChooser.showOpenDialog(null);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = jFileChooser.getSelectedFile();
            settings.setVideoFile(file.getPath());
            readMetadata(settings.getVideoFile());

            stateManager.setState(State.FILEMETAINFO);
        }
    }

    private void readMetadata(String file) {
        MediaPlayerFactory mediaPlayerFactory = new MediaPlayerFactory("--no-video-title-show", "--quiet");
        DirectMediaPlayer mediaPlayer = mediaPlayerFactory.newDirectMediaPlayer(1, 1, new RenderCallback() {
            public void display(DirectMediaPlayer dmp, Memory[] memorys, BufferFormat bf) {
            }
        });
        mediaPlayer.setVolume(0);
        mediaPlayer.prepareMedia(file);
        mediaPlayer.play();
        try {
            Thread.sleep(SLEEP);
        } catch (Exception ex) {
        }
        settings.useVideo(mediaPlayer.getVideoTrackCount() > 0);
        settings.setTrackTitle(mediaPlayer.getMediaMeta().getTitle());
        settings.setTrackArtist(mediaPlayer.getMediaMeta().getArtist());
        settings.setTrackLength(Math.round((float) mediaPlayer.getLength() / 1000f));

        mediaPlayer.stop();
        mediaPlayer.release();
        mediaPlayerFactory.release();
    }

    public void downloadYT() {
        stateManager.setState(State.YTDOWNLOAD);
    }

    public void cancel() {
        stateManager.setState(State.MENU);
    }
}
